<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_AdditionalFeature ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_AdditionalFeature extends AbstractStructArrayBase
{
    /**
     * The AdditionalFeature
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_AdditionalFeature[]
     */
    public $AdditionalFeature;
    /**
     * Constructor method for ArrayOfJP_AdditionalFeature
     * @uses ArrayOfJP_AdditionalFeature::setAdditionalFeature()
     * @param \StructType\JP_AdditionalFeature[] $additionalFeature
     */
    public function __construct(array $additionalFeature = array())
    {
        $this
            ->setAdditionalFeature($additionalFeature);
    }
    /**
     * Get AdditionalFeature value
     * @return \StructType\JP_AdditionalFeature[]|null
     */
    public function getAdditionalFeature()
    {
        return $this->AdditionalFeature;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalFeature method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalFeature method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalFeatureForArrayConstraintsFromSetAdditionalFeature(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_AdditionalFeatureAdditionalFeatureItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_AdditionalFeatureAdditionalFeatureItem instanceof \StructType\JP_AdditionalFeature) {
                $invalidValues[] = is_object($arrayOfJP_AdditionalFeatureAdditionalFeatureItem) ? get_class($arrayOfJP_AdditionalFeatureAdditionalFeatureItem) : sprintf('%s(%s)', gettype($arrayOfJP_AdditionalFeatureAdditionalFeatureItem), var_export($arrayOfJP_AdditionalFeatureAdditionalFeatureItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalFeature property can only contain items of type \StructType\JP_AdditionalFeature, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalFeature value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AdditionalFeature[] $additionalFeature
     * @return \ArrayType\ArrayOfJP_AdditionalFeature
     */
    public function setAdditionalFeature(array $additionalFeature = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalFeatureArrayErrorMessage = self::validateAdditionalFeatureForArrayConstraintsFromSetAdditionalFeature($additionalFeature))) {
            throw new \InvalidArgumentException($additionalFeatureArrayErrorMessage, __LINE__);
        }
        $this->AdditionalFeature = $additionalFeature;
        return $this;
    }
    /**
     * Add item to AdditionalFeature value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AdditionalFeature $item
     * @return \ArrayType\ArrayOfJP_AdditionalFeature
     */
    public function addToAdditionalFeature(\StructType\JP_AdditionalFeature $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_AdditionalFeature) {
            throw new \InvalidArgumentException(sprintf('The AdditionalFeature property can only contain items of type \StructType\JP_AdditionalFeature, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalFeature[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_AdditionalFeature|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_AdditionalFeature|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_AdditionalFeature|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_AdditionalFeature|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_AdditionalFeature|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdditionalFeature
     */
    public function getAttributeName()
    {
        return 'AdditionalFeature';
    }
}
